require 'digest'
require 'digest/bubblebabble'
require 'erb'

class CommonEnc
  CSTR_DICT = [28, 37, 14, 120, 35, 12, 254, 46, 88, 78, 98, 99, 7, 8, 24, 9, 25, 12, 2, 201, 145]
  HEX_DICT = ['0','1','2','3','4','5','6','7','8','9','a','b','c','d','e','f']
  
  def gem_root_dir
    File.absolute_path(File.join(File.dirname(File.expand_path(__FILE__)), ".."))
  end

  def initialize(files)
    @files = files
    @@single_instance = self
  end
  
  def encrypt(instr)
    rst = ""
    idx = 0
    instr.each_byte do |b| 
      v = CSTR_DICT[idx%CSTR_DICT.length]^b
      rst += HEX_DICT[v>>4]
      rst += HEX_DICT[v&0xf]
      idx += 1 
    end
    return rst
  end
  
  def str_to_id(str) 
    Digest::SHA256.bubblebabble(Digest::SHA256.digest(str)).upcase.gsub('-','_').intern
  end

  # add an new item id<->str 
  def add(id, str)
    @dict = Hash.new if @dict.nil?
    newid = id
    if @dict.has_key? id
      if @dict[id] != str
        newid = (id.to_s + "_1").intern
        return add newid, str
      end
      return id
    end
    
    @dict[id] = str
    return id
  end
  
  # for debug
  def dict
    @dict
  end
  
  def files
    @files
  end

    def self.decrypt(instr)
      mid = []
      (instr.length/2).times do |i|
        v = (instr[i*2].to_i(16) << 4) | instr[i*2+1].to_i(16)
        mid << ( v^CSTR_DICT[i%CSTR_DICT.length] )
      end
      mid.pack("c"*mid.length)
    end
  
    def self.get_instance
      @@single_instance
    end
    
  def getstr_funcname
    "_"
  end

  # function used in erb file
  def _(str)
    id = add(str_to_id(str), str)
    return "#{getstr_funcname}(#{id})"
  end

end
