#!/usr/bin/ruby
# -!- encoding: utf-8 -!-

require 'thor'
require 'ecstr'
require 'ejstr'

class ESS < Thor
  class_option :key, :aliases => '-k', :type => :array, :banner => '加密密钥，不指定是将使用随机生成的密钥'

  desc 'c [OPTIONS] FILES', '将C/C++/ObjC源文件FILES变换成使用加密数据库的源文件'
  option :gtest, :default => false, :aliases => '-g', :type => :boolean, :banner => '是否生成gtest测试用例（只对c代码有效）'
  option :outputdir, :default => "./", :aliases => '-o', :type => :string, :banner => '输出文件目录，默认为输入文件相同目录'
  def c(*files)
    ECStr.new(files).run
  end

  desc "java [OPTIONS] FILES", "将Java源文件变换成使用加密字符串的源文件"
  option :pkg_name, :aliases => '-p', :type => :string, :banner => '生成的加密库文件所在包名', :default => "net.z4tech.enstr"
  option :clz_name, :aliases => '-c', :type => :string, :banner => '生成的加密库文件字符串解密函数所在函数名', :default => "EJStr"
  def java(*files)
    EJStr.new(files, options[:pkg_name], options[:clz_name]).run
  end
end
